# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Test2
Summary:	Framework for writing test tools that all work together
Version:	1.302078
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Test-Simple
Source0:	http://search.cpan.org/CPAN/authors/id/E/EX/EXODIST/Test-Simple-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Scalar::Util) >= 1.13
BuildRequires:	perl(Storable)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(base)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IO::Pipe)
BuildRequires:	perl(lib)
BuildRequires:	perl(overload)
BuildRequires:	perl(PerlIO)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(threads)
BuildRequires:	perl(vars)
# Optional Tests
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.120920
BuildRequires:	perl(IPC::SysV)
BuildRequires:	perl(Module::Metadata)
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Test::Harness) >= 2.03
BuildRequires:	perl(Test::Pod) >= 0.95
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Data::Dumper)
Requires:	perl(Exporter)

%description
Test2 is a new Perl testing framework produced by forking Test::Builder,
completely refactoring it, adding many new features and capabilities.

%prep
%setup -q -n Test-Simple-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes README examples/
%{perl_vendorlib}/Test2.pm
%{perl_vendorlib}/Test2/
%{_mandir}/man3/Test2.3*
%{_mandir}/man3/Test2::API.3*
%{_mandir}/man3/Test2::API::Breakage.3*
%{_mandir}/man3/Test2::API::Context.3*
%{_mandir}/man3/Test2::API::Instance.3*
%{_mandir}/man3/Test2::API::Stack.3*
%{_mandir}/man3/Test2::Event.3*
%{_mandir}/man3/Test2::Event::Bail.3*
%{_mandir}/man3/Test2::Event::Diag.3*
%{_mandir}/man3/Test2::Event::Encoding.3*
%{_mandir}/man3/Test2::Event::Exception.3*
%{_mandir}/man3/Test2::Event::Generic.3*
%{_mandir}/man3/Test2::Event::Info.3*
%{_mandir}/man3/Test2::Event::Note.3*
%{_mandir}/man3/Test2::Event::Ok.3*
%{_mandir}/man3/Test2::Event::Plan.3*
%{_mandir}/man3/Test2::Event::Skip.3*
%{_mandir}/man3/Test2::Event::Subtest.3*
%{_mandir}/man3/Test2::Event::TAP::Version.3*
%{_mandir}/man3/Test2::Event::Waiting.3*
%{_mandir}/man3/Test2::Formatter.3*
%{_mandir}/man3/Test2::Formatter::TAP.3*
%{_mandir}/man3/Test2::Hub.3*
%{_mandir}/man3/Test2::Hub::Interceptor.3*
%{_mandir}/man3/Test2::Hub::Interceptor::Terminator.3*
%{_mandir}/man3/Test2::Hub::Subtest.3*
%{_mandir}/man3/Test2::IPC.3*
%{_mandir}/man3/Test2::IPC::Driver.3*
%{_mandir}/man3/Test2::IPC::Driver::Files.3*
%{_mandir}/man3/Test2::Tools::Tiny.3*
%{_mandir}/man3/Test2::Transition.3*
%{_mandir}/man3/Test2::Util.3*
%{_mandir}/man3/Test2::Util::ExternalMeta.3*
%{_mandir}/man3/Test2::Util::HashBase.3*
%{_mandir}/man3/Test2::Util::Trace.3*
# Exclude legacy module support that would conflict with the system perl-Test-Simple package
%exclude %{perl_vendorlib}/ok.pm
%exclude %{perl_vendorlib}/Test/
%exclude %{_mandir}/man3/ok.3*
%exclude %{_mandir}/man3/Test::Builder.3*
%exclude %{_mandir}/man3/Test::Builder::Formatter.3*
%exclude %{_mandir}/man3/Test::Builder::IO::Scalar.3*
%exclude %{_mandir}/man3/Test::Builder::Module.3*
%exclude %{_mandir}/man3/Test::Builder::Tester.3*
%exclude %{_mandir}/man3/Test::Builder::Tester::Color.3*
%exclude %{_mandir}/man3/Test::Builder::TodoDiag.3*
%exclude %{_mandir}/man3/Test::More.3*
%exclude %{_mandir}/man3/Test::Simple.3*
%exclude %{_mandir}/man3/Test::Tester.3*
%exclude %{_mandir}/man3/Test::Tester::Capture.3*
%exclude %{_mandir}/man3/Test::Tester::CaptureRunner.3*
%exclude %{_mandir}/man3/Test::Tutorial.3*
%exclude %{_mandir}/man3/Test::use::ok.3*

%changelog
* Thu Mar  2 2017 Paul Howarth <paul@city-fan.org> - 1.302078-1
- Update to 1.302078
  - Fix crash when TB->reset used inside subtest
  - Fix #762, newlines for todo subtest
  - Revisit #637, fix rare race condition it created

* Wed Jan 11 2017 Paul Howarth <paul@city-fan.org> - 1.302075-1
- Update to 1.302075
  - Add 'cid' to trace
  - Add signatures to trace
  - Add related() to events
  - Now it is possible to check if events are related
  - Add 'no_fork' option to run_subtest()

* Mon Dec 19 2016 Paul Howarth <paul@city-fan.org> - 1.302073-1
- Update to 1.302073
  - Add TO_JSON and from_json methods to Test2::Event and Test2::Trace::Util to
    facilitate transferring event data between processes (#741)
  - Generate HashBase from Object::HashBase, which has been split out
  - When a subtest is marked as todo, all of its contained Ok and Subtest
    events are now updated so that they return true for $e->effective_pass
    (#742)
  - Added two new event classes, Test2::Event::Encoding and
    Test2::Event::TAP::Version; these are primarily being added for the benefit
    of Test2::Harness now, but they could be useful for other Test2 event
    consumer tools in the future (#743)
  - Expose tools.pl as Test2::Tools::Tiny

* Thu Nov 24 2016 Paul Howarth <paul@city-fan.org> - 1.302067-1
- Update to 1.302067
  - Fix double release when 'throw' is used in context_do()
  - Repo management improvements
  - Better handling of info vs. diag in ->send_event
  - Fix test that used 'parent'
  - Better handling of non-bumping failures (#728)
  - Set the TEST_ACTIVE env var to true
  - Set the TEST2_ACTIVE env var to true
  - Fix cmp_ok output in some confusing cases (#6)
  - Update travis config
  - Add missing author deps
  - Fix handling of negative pids on Windows
  - Add can() to Test::Tester::Delegate (despite deprecation)
  - Fix some minor test issues
  - Handle cases where SysV IPC can be available but not enabled
  - Import 'context' into Test2::IPC; it is used by 'cull'
  - Propagate warnings settings to use_ok (#736)
  - Fix context test for recent blead

* Thu Oct 20 2016 Paul Howarth <paul@city-fan.org> - 1.302062-1
- Update to 1.302062
  - Formatters now have terminate() and finalize() methods; these are called
    when there is a skip_all or bail event (terminate), or when a test suite is
    exiting normally (finalize), which allows formatters to finalize their
    output - this is important for any sort of document-oriented format (as
    opposed to a stream format like TAP) (#723)
  - Removed a warning when using a non-TAP formatter with Test::Builder about
    the formatter not supporting "no_header" and "no_diag"; this happened even
    if the alternative formatter class implemented these attributes

* Mon Sep 26 2016 Paul Howarth <paul@city-fan.org> - 1.302059-1
- Update to 1.302059
  - Documentation fixes
  - Win32 color support in Test::Builder::Tester
  - Support v-strings in is_deeply
  - A streamed subtest run inside a buffered subtest will automatically be
    converted to a buffered subtest; otherwise, the output from inside the
    subtest is lost entirely (#721)
  - Mask warning when comparing $@ in Test2::API::Context

* Tue Sep 13 2016 Paul Howarth <paul@city-fan.org> - 1.302056-1
- Update to 1.302056
  - Fix skip_all in require in intercept (#696)
  - Documentation of what is better in Test2 (#663)
  - Document Test::Builder::Tester plan limitations
  - Document limitations in is_deeply (#595)
  - Better documentation of done_testing purpose (#151)
  - Make ctx->send_event detect termination events (#707)
  - Allow '#' and '\n' in ok names
  - Fix special case of ok line ending in backslash
  - Improve a test that captures STDERR/STDOUT

* Sun Aug 14 2016 Paul Howarth <paul@city-fan.org> - 1.302052-1
- Update to 1.302052
  - Add contact info to main doc and readme
  - Fix setting hub when getting context

* Fri Jul 29 2016 Paul Howarth <paul@city-fan.org> - 1.302049-1
- Update to 1.302049
  - Add 'active' attribute to hub

* Sat Jul 23 2016 Paul Howarth <paul@city-fan.org> - 1.302047-1
- Update to 1.302047
  - Restore traditional note/diag return values (#694)

* Tue Jul 19 2016 Paul Howarth <paul@city-fan.org> - 1.302045-1
- Update to 1.302045
  - Work around IPC bug on windows
  - Fix IPC event ordering bug
  - Fix TODO in mixed T2/TB subtests
  - Fix test that segv'd on older perls

* Sun Jul 10 2016 Paul Howarth <paul@city-fan.org> - 1.302040-1
- Update to 1.302040
  - Fix broken MANIFEST.SKIP entries (#689)
  - Add Info event for better diagnostics

* Mon Jul  4 2016 Paul Howarth <paul@city-fan.org> - 1.302037-1
- Update to 1.302037
  - Restore PerlIO layer cloning on STDERR and STDOUT

* Thu Jun 30 2016 Paul Howarth <paul@city-fan.org> - 1.302035-1
- Initial RPM package, ported from Fedora's perl-Test-Simple
